//+------------------------------------------------------------------+
//|                                              EqualVolumeBars.mq4 |
//|                                      Copyright  2008, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"
#property show_inputs

#include <WinUser32.mqh>

#import "mt4excel.dll"
   bool  ExcelOpenFile(string FileName);//  Excel
   double  ExcelGetValueCell(int X,int Y);//   
   string ExcelGetLastErrorText();//   Excel
#import
//----     
extern string ExcelFile="D:\1.xlsx";
extern int		TicksInBar	= 1;

double Open_[],
       Close_[],
       High_[],
       Low_[];
int Time_[];
int HistoryHandle = -1, HistoryFilePos = 0, hwnd = 0, TicksFilePos = 0, now_time;
double now_close, now_open, now_low, now_high, now_volume;
string _Symbol;

int _Period, _PeriodSec, pre_time, last_fpos = 0;
double pre_close;

int init()
{
	int    _GetLastError = 0, cnt_ticks = 0, cnt_bars = 0, temp[13];
	//   ,    off-line 
	_Symbol = Symbol();
   hwnd = 0;

	//  ,     
	string file_name = StringConcatenate( "!Eqv", _Symbol, TicksInBar, ".hst" );
	int sd_=iBars("!Eqv"+ _Symbol,TicksInBar)-1;
   double Open_[],
          Close_[],
          High_[],
          Low_[];
   int Time_[];
   ArrayResize(Open_,sd_+1);
   ArrayResize(High_,sd_+1);
   ArrayResize(Low_,sd_+1);
   ArrayResize(Close_,sd_+1);
   ArrayResize(Time_,sd_+1);
	for(int sd=iBars("!Eqv"+ _Symbol,TicksInBar)-1;sd>=0;sd--)
	{
	   Time_[sd]=iTime("!Eqv"+ _Symbol,TicksInBar,sd);
	   Open_[sd]=iOpen("!Eqv"+ _Symbol,TicksInBar,sd);
	   Close_[sd]=iClose("!Eqv"+ _Symbol,TicksInBar,sd);
	   High_[sd]=iHigh("!Eqv"+ _Symbol,TicksInBar,sd);
	   Low_[sd]=iLow("!Eqv"+ _Symbol,TicksInBar,sd);
	   //Print(sd," ",GetLastError()," ",Time_[sd]," ",Low_[sd]," ",High_[sd]," ",Close_[sd]," ",Open_[sd]);
	}
	HistoryHandle = FileOpenHistory( file_name, FILE_BIN | FILE_WRITE );
	if ( HistoryHandle < 0 )
	{
		_GetLastError = GetLastError();
		Alert( "FileOpenHistory( \"", file_name, "\", FILE_BIN | FILE_WRITE )", " - Error #", _GetLastError );
		return(-1);
	}

	//----   
	FileWriteInteger	( HistoryHandle, 400, LONG_VALUE );
	FileWriteString	( HistoryHandle, "Copyright  2008, komposter", 64 );
	FileWriteString	( HistoryHandle, StringConcatenate( "!Eqv", _Symbol ), 12 );
	FileWriteInteger	( HistoryHandle, TicksInBar, LONG_VALUE );
	FileWriteInteger	( HistoryHandle, Digits, LONG_VALUE );
	FileWriteInteger	( HistoryHandle, 0, LONG_VALUE );       //timesign
	FileWriteInteger	( HistoryHandle, 0, LONG_VALUE );       //last_sync
	FileWriteArray		( HistoryHandle, temp, 0, 13 );

   for(int sd1=sd_;sd1>=0;sd1--)
   {
   	FileWriteInteger	( HistoryHandle, Time_[sd1],		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, Open_[sd1],		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, Low_[sd1],		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, High_[sd1],		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, Close_[sd1],	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, TicksInBar,	DOUBLE_VALUE);
	   FileFlush			( HistoryHandle );
	   //Print(sd1," ",GetLastError()," ",Time_[sd1]," ",Low_[sd1]," ",High_[sd1]," ",Close_[sd1]," ",Open_[sd1]);
   }
   now_time=Time_[0];
	//    ,   0- 
	HistoryFilePos = FileTell( HistoryHandle);

	//  0-     
	FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
	FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
	FileFlush			( HistoryHandle );

	//  
	Print( "< - - -  : ", sd_+1, ",   : ", sd_+1, " - - - >" );
	Print( "< - - -      \"!Eqv", _Symbol, TicksInBar, "\" - - - >" );
	
	//  
	RefreshWindow();
   ArrayResize(Open_,1);
   ArrayResize(High_,1);
   ArrayResize(Low_,1);
   ArrayResize(Close_,1);
   ArrayResize(Time_,1);

	return(0);
}

int start()
{
   if (ExcelOpenFile(ExcelFile)) 
      Print("c  Excel"); 
   else
   { 
      Print("  Excel:",ExcelGetLastErrorText());// Excel        
      //return;
   }
   double Bid_=ExcelGetValueCell(1,1);
   //ExcelGetValueCell(1,1)
   while(!IsStopped())
   {
   RefreshRates();
	if ( HistoryHandle < 0 ) continue;//(-1);
	if(ExcelGetValueCell(1,1)==Bid_)
	{
	   Sleep(11);
	   continue;
	}
   Bid_=ExcelGetValueCell(1,1);
	//+------------------------------------------------------------------+
	//|   
	//+------------------------------------------------------------------+
	//----  ""   
	FileSeek( HistoryHandle, HistoryFilePos, SEEK_SET );

	now_volume ++;

	//  
	if ( now_volume <= TicksInBar )
	{
		if ( Bid_ < now_low  ) now_low  = Bid_;
		if ( Bid_ > now_high ) now_high = Bid_;
		now_close = Bid_;

		//  0-     
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
	}
	//    
	else
	{
		//  1- 
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume-1,DOUBLE_VALUE);
		FileFlush			( HistoryHandle );

//		now_time		= TimeCurrent();
		now_time		+= 60;	//   ,    2    
		now_open		= Bid_;
		now_low		= Bid_;
		now_high		= Bid_;
		now_close	= Bid_;
		now_volume	= 1;

		//    ,   0- 
		HistoryFilePos = FileTell( HistoryHandle);

		//  0- 
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
	}
/*
// Print( "now_time = ", now_time, ", now_open = ", now_open, ", now_low = ", now_low, ", now_high = ", now_high, ", now_close = ", now_close, ", now_volume = ", now_volume );
// Print( "5:  file_pos = ", FileTell( HistoryHandle) );
	//     
	FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
	FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
	FileFlush			( HistoryHandle );

// Print( "6:  file_pos = ", FileTell( HistoryHandle) );
*/
	//  
	RefreshWindow();
	Sleep(100);
	}
	deinit();
}

void RefreshWindow()
{
	//----  ,    ""  
	if ( hwnd == 0 )
	{
		hwnd = WindowHandle( StringConcatenate( "!Eqv", _Symbol ), TicksInBar );
		if ( hwnd != 0 ) { Print( "< - - -  ", "!Eqv", _Symbol, TicksInBar, " ! - - - >" ); }
	}
	//---- ,  ,  
	if ( hwnd != 0 ) { PostMessageA( hwnd, WM_COMMAND, 33324, 0 ); }
}

int deinit()
{
	if ( HistoryHandle > 0 )
	{
		//----  
		FileClose( HistoryHandle );
		HistoryHandle = -1;
	}
	return(0);
}

string strMonth( int m )
{
	if ( m < 10 ) return( StringConcatenate( "0", m ) );
	return(m);
}